Index: code/branches/ingamemenu/src/orxonox/gamestates/GSGraphics.cc
===================================================================
--- code/branches/ingamemenu/src/orxonox/gamestates/GSGraphics.cc	(revision 5999)
+++ code/branches/ingamemenu/src/orxonox/gamestates/GSGraphics.cc	(revision 6003)
@@ -64,6 +64,5 @@
     void GSGraphics::activate()
     {
-        // add console command to toggle GUI
-        CommandExecutor::addConsoleCommandShortcut(createConsoleCommand(createFunctor(&GSGraphics::toggleGUI, this), "toggleGUI"));
+        
     }
 
@@ -78,16 +77,4 @@
     }
 
-    /**
-    @brief
-        Toggles the visibility of the current GUI
-
-        This function just executes a Lua function in the main script of the GUI by accessing the GUIManager.
-        For more details on this function check out the Lua code.
-    */
-    void GSGraphics::toggleGUI()
-    {
-        GUIManager::getInstance().executeCode("toggleGUI()");
-    }
-
     void GSGraphics::update(const Clock& time)
     {
Index: code/branches/ingamemenu/src/orxonox/gamestates/GSGraphics.h
===================================================================
--- code/branches/ingamemenu/src/orxonox/gamestates/GSGraphics.h	(revision 5999)
+++ code/branches/ingamemenu/src/orxonox/gamestates/GSGraphics.h	(revision 6003)
@@ -57,6 +57,4 @@
         void update(const Clock& time);
 
-        void toggleGUI();
-
     private:
     };
Index: code/branches/ingamemenu/src/orxonox/gamestates/GSLevel.cc
===================================================================
--- code/branches/ingamemenu/src/orxonox/gamestates/GSLevel.cc	(revision 5999)
+++ code/branches/ingamemenu/src/orxonox/gamestates/GSLevel.cc	(revision 6003)
@@ -101,13 +101,9 @@
         if (show)
         {
-            GUIManager::getInstance().showGUI("inGameTest");
-            GUIManager::getInstance().executeCode("showCursor()");
-            InputManager::getInstance().enterState("guiMouseOnly");
+            GUIManager::showGUI("inGameTest");
         }
         else
         {
-            GUIManager::getInstance().executeCode("hideGUI(\"inGameTest\")");
-            GUIManager::getInstance().executeCode("hideCursor()");
-            InputManager::getInstance().leaveState("guiMouseOnly");
+            GUIManager::hideGUI("inGameTest");
         }
     }
Index: code/branches/ingamemenu/src/orxonox/gamestates/GSMainMenu.cc
===================================================================
--- code/branches/ingamemenu/src/orxonox/gamestates/GSMainMenu.cc	(revision 5999)
+++ code/branches/ingamemenu/src/orxonox/gamestates/GSMainMenu.cc	(revision 6003)
@@ -82,5 +82,5 @@
     {
         // show main menu
-        GUIManager::getInstance().showGUI("MainMenu");
+        GUIManager::showGUI("MainMenu");
         GUIManager::getInstance().setCamera(this->camera_);
         GraphicsManager::getInstance().setCamera(this->camera_);
@@ -111,4 +111,5 @@
 
         InputManager::getInstance().leaveState("mainMenu");
+        GUIManager::hideGUI("MainMenu");
 
         GUIManager::getInstance().setCamera(0);
Index: code/branches/ingamemenu/src/orxonox/pickup/PickupInventory.cc
===================================================================
--- code/branches/ingamemenu/src/orxonox/pickup/PickupInventory.cc	(revision 5999)
+++ code/branches/ingamemenu/src/orxonox/pickup/PickupInventory.cc	(revision 6003)
@@ -86,13 +86,9 @@
     {
         if(PickupInventory::getSingleton()->isVisible()) {
-            GUIManager::getInstance().executeCode("hideGUI(\"PickupInventory\")");
-            GUIManager::getInstance().executeCode("hideCursor()");
-            InputManager::getInstance().leaveState("guiMouseOnly");
-        }
-        else
-        {
-            GUIManager::getInstance().showGUI("PickupInventory");
-            GUIManager::getInstance().executeCode("showCursor()");
-            InputManager::getInstance().enterState("guiMouseOnly");
+            GUIManager::hideGUI("PickupInventory");
+        }
+        else
+        {
+            GUIManager::showGUI("PickupInventory");
         }
         PickupInventory::getSingleton()->setVisible(!PickupInventory::getSingleton()->isVisible());
Index: code/branches/ingamemenu/src/orxonox/pickup/PickupSpawner.cc
===================================================================
--- code/branches/ingamemenu/src/orxonox/pickup/PickupSpawner.cc	(revision 5999)
+++ code/branches/ingamemenu/src/orxonox/pickup/PickupSpawner.cc	(revision 6003)
@@ -96,6 +96,6 @@
         //  & load the GUI itself too, along with some empty windows
         //   = even less delays
-        GUIManager::getInstance().showGUI("PickupInventory");
-        GUIManager::getInstance().executeCode("hideGUI(\"PickupInventory\")");
+        GUIManager::showGUI("PickupInventory");
+        GUIManager::hideGUI("PickupInventory");
         PickupInventory::getSingleton();
     }