Index: code/branches/sound3/data/levels/sound.oxw
===================================================================
--- code/branches/sound3/data/levels/sound.oxw	(revision 6099)
+++ code/branches/sound3/data/levels/sound.oxw	(revision 6100)
@@ -17,6 +17,7 @@
     skybox       = "Orxonox/Starbox"
   >
-  <AmbientSound source="Mars.ogg" loop="true" playOnLoad="true" />
-  <AmbientSound source="Asteroid_rocks.ogg" loop="true" playOnLoad="false">
+
+  <AmbientSound source="Mars.ogg" loop="true" play="true" />
+  <AmbientSound source="Asteroid_rocks.ogg" loop="true" play="false">
 	<events>
 		<activity>
@@ -29,6 +30,7 @@
 	</events>
   </AmbientSound>
-    <Light type=directional position="0,0,0" direction="0.253, 0.593, -0.765" diffuse="1.0, 0.9, 0.9, 1.0" specular="1.0, 0.9, 0.9, 1.0" />
-    <SpawnPoint position="0,0,0" spawnclass=SpaceShip pawndesign=spaceshippirate />
+
+  <Light type=directional position="0,0,0" direction="0.253, 0.593, -0.765" diffuse="1.0, 0.9, 0.9, 1.0" specular="1.0, 0.9, 0.9, 1.0" />
+  <SpawnPoint position="0,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff />
   </Scene>
 </Level>
Index: code/branches/sound3/data/levels/templates/spaceship_assff.oxt
===================================================================
--- code/branches/sound3/data/levels/templates/spaceship_assff.oxt	(revision 6099)
+++ code/branches/sound3/data/levels/templates/spaceship_assff.oxt	(revision 6100)
@@ -76,12 +76,15 @@
       <Light mainstate=visibility position="-8, 0, 8" diffuse="0.3, 0.6, 1.0" specular="0.3, 0.6, 1.0" attenuation="600, 1.0, 0.007, 0.0002" type=point />
 -->
+      <!--WorldSound mainstate=activity source="sounds/Engine_low.ogg" oop=1 /-->
     </active>
     <forward>
       <Backlight mainstate=activity active=false scale=0.4 name=bltest position=" 7.6, 0, 6" colour="0.2, 0.65, 1.0, 1.0" width=15 length=1500 lifetime=2 elements=50 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Flares/ThrusterFlare1" />
       <Backlight mainstate=activity active=false scale=0.4 name=bltest position="-7.6, 0, 6" colour="0.2, 0.65, 1.0, 1.0" width=15 length=1500 lifetime=2 elements=50 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Flares/ThrusterFlare1" />
+      <WorldSound mainstate=activity source="sounds/Engine_low.ogg" oop=1 />
     </forward>
     <boost>
       <Backlight mainstate=activity active=false scale=0.4 name=bltest position=" 7.6, 0, 6" colour="0.6, 0.75, 0.8, 0.7" width=40 length=1000 lifetime=1 elements=30 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Examples/Flare" />
       <Backlight mainstate=activity active=false scale=0.4 name=bltest position="-7.6, 0, 6" colour="0.6, 0.75, 0.8, 0.7" width=40 length=1000 lifetime=1 elements=30 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Examples/Flare" />
+      <!--WorldSound mainstate=activity source="sounds/Engine_high.ogg" oop=1 /-->
     </boost>
     <brake>
Index: code/branches/sound3/src/orxonox/sound/AmbientSound.cc
===================================================================
--- code/branches/sound3/src/orxonox/sound/AmbientSound.cc	(revision 6099)
+++ code/branches/sound3/src/orxonox/sound/AmbientSound.cc	(revision 6100)
@@ -125,14 +125,9 @@
     void AmbientSound::changedActivity() 
     {
-        COUT(3) << "Sound: " << this->getSource() << ": ChangedActivity: " << this->isActive() << std::endl;
-        this->BaseObject::changedActivity();
+        SUPER(AmbientSound, changedActivity);
         if (this->isActive())
-        {
             this->play();
-        }
         else 
-        {
             this->stop();
-        }
     }
 }
Index: code/branches/sound3/src/orxonox/sound/WorldSound.cc
===================================================================
--- code/branches/sound3/src/orxonox/sound/WorldSound.cc	(revision 6099)
+++ code/branches/sound3/src/orxonox/sound/WorldSound.cc	(revision 6100)
@@ -89,3 +89,12 @@
         }
     }
+
+    void WorldSound::changedActivity() 
+    {
+        SUPER(WorldSound, changedActivity);
+        if (this->isActive())
+            this->play();
+        else 
+            this->stop();
+    }
 }
Index: code/branches/sound3/src/orxonox/sound/WorldSound.h
===================================================================
--- code/branches/sound3/src/orxonox/sound/WorldSound.h	(revision 6099)
+++ code/branches/sound3/src/orxonox/sound/WorldSound.h	(revision 6100)
@@ -50,4 +50,5 @@
         virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
         virtual void XMLEventPort(Element& xmlelement, XMLPort::Mode mode);
+        virtual void changedActivity();
 
         virtual void tick(float dt);